import {join as $4X1qT$join, dirname as $4X1qT$dirname} from "path";
import $4X1qT$fs from "fs";
import $4X1qT$chalkesm from "chalk-esm";





const $912105aa7099884f$export$8f45430ccf837300 = {
    black: (0, $4X1qT$chalkesm).hex("#000000"),
    scarlet: (0, $4X1qT$chalkesm).hex("#e83f25"),
    carmine: (0, $4X1qT$chalkesm).hex("#960018"),
    brown: (0, $4X1qT$chalkesm).hex("#ad6744"),
    green: (0, $4X1qT$chalkesm).hex("#00d11f"),
    yellow: (0, $4X1qT$chalkesm).hex("#9da133"),
    blue: (0, $4X1qT$chalkesm).hex("#0a44a8"),
    lightblue: (0, $4X1qT$chalkesm).hex("#2461c9"),
    verbose_color: (0, $4X1qT$chalkesm).hex("#8a919c")
};
const $912105aa7099884f$export$7542c0aa3a589090 = {
    black: "#000000",
    scarlet: "#e83f25",
    carmine: "#960018",
    brown: "#ad6744",
    green: "#00d11f",
    yellow: "#9da133",
    blue: "#0a44a8",
    lightblue: "#2461c9",
    verbose_color: "#8a919c"
};


function $830de6b205d78ea3$export$c10215e37b232ccd(text, color = "black", ...notColoredTexts) {
    // const colors: { [key in Tcolor]: ChalkInstance } = {
    const coloredText = (0, $912105aa7099884f$export$8f45430ccf837300)[color](text) + notColoredTexts;
    return coloredText;
}
function $830de6b205d78ea3$export$cc349de0efd0b6c9(text, color = "black", ...notColoredTexts) {
    const coloredText = $830de6b205d78ea3$export$c10215e37b232ccd(text, color);
    console.log(coloredText, ...notColoredTexts);
}
const $830de6b205d78ea3$export$dbe72820abab9377 = (...texts)=>texts.map((text)=>{
        if (typeof text === "object") return JSON.stringify(text);
        return text;
    });
function $830de6b205d78ea3$export$28d70ad760c155a4(text, fileName, separeteLogsByDate) {
    if (!fileName) return;
    if (separeteLogsByDate) {
        var months = [
            "January",
            "February",
            "March",
            "April",
            "May",
            "June",
            "July",
            "August",
            "September",
            "October",
            "November",
            "December"
        ];
        const date = new Date();
        const year = date.getFullYear();
        const monthName = months[date.getMonth()];
        const dir = monthName + "_" + year;
        const day = date.getDate();
        fileName = (0, $4X1qT$join)((0, $4X1qT$dirname)(fileName), dir, day + ".log");
    }
    if (!(0, $4X1qT$fs).existsSync(fileName)) {
        const dir1 = (0, $4X1qT$dirname)(fileName);
        (0, $4X1qT$fs).mkdirSync(dir1, {
            recursive: true
        });
    }
    try {
        (0, $4X1qT$fs).appendFileSync(fileName, text);
    } catch (error) {
        console.error($830de6b205d78ea3$export$cc349de0efd0b6c9("LOGGING ERROR: ", "scarlet", error.message));
    }
}
function $830de6b205d78ea3$export$2364d538c15eb8db() {
    var currentDate = new Date();
    const date = currentDate.toLocaleDateString("en-US");
    const time = currentDate.toLocaleTimeString("en-US");
    return `${date} | ${time}`;
}


const $9506e65438fa5fe0$var$loggingValues = {
    fatal: 0,
    error: 1,
    warn: 2,
    important: 3,
    success: 4,
    info: 5,
    verbose: 6
};
class $9506e65438fa5fe0$var$OurLogging {
    #logLevel = 6;
    #logFileName;
    #separeteLogsByDate = false;
    /**
     * If enabled will sort all new logs in directory by MONTH_YYYY with names DD.log
     * eg October_2022/31.log
     */ setSeparateLogsByDate(value) {
        this.#separeteLogsByDate = value;
    }
    /**
     * logs by level decrease: 'fatal' | 'error' | 'warn' | 'important' | 'info' | 'success' | 'verbose'
     * @param level log that you want to see in console
     * @example logging.setLogLevel('important')
     * // After that only fatal, error, warn, important logs will shown
     */ setLogLevel(newLevel) {
        this.#logLevel = $9506e65438fa5fe0$var$loggingValues[newLevel];
    }
    /**
     * @param path full path to directory where you want to save logs
     */ setLogPath(path) {
        this.#logFileName = (0, $4X1qT$join)(path, "log.log");
    }
    /**
     * Use only for most important staff like db connection
     * Will show stack in console
     * @param text will be seen first by user
     * @param stackTrace will be showed after text and logged into file
     * @example throw logging.fatal('DB connection error', err.stack)
     * @returns Error object with text
     */ fatal(...texts) {
        const currentTime = (0, $830de6b205d78ea3$export$2364d538c15eb8db)();
        (0, $830de6b205d78ea3$export$cc349de0efd0b6c9)("[ FATAL ERROR ]", "scarlet", `${currentTime} | `, ...texts);
        const textsInNormalRepresentation = (0, $830de6b205d78ea3$export$dbe72820abab9377)(...texts);
        const textsForPrint = textsInNormalRepresentation.join(" ");
        let logText = `\n[ FATAL ERROR ] ${currentTime} | ${textsForPrint}`;
        (0, $830de6b205d78ea3$export$28d70ad760c155a4)(logText, this.#logFileName, this.#separeteLogsByDate);
        return new Error(logText);
    }
    /**
     * Important but not cicritical errors
     * @param text
     * @returns Error object with error text
     */ error(...texts) {
        if (!this.#aboveSelectedLogLevel("error")) return;
        const currentTime = (0, $830de6b205d78ea3$export$2364d538c15eb8db)();
        (0, $830de6b205d78ea3$export$cc349de0efd0b6c9)("[ ERROR ] ", "scarlet", `${currentTime} | `, ...texts);
        const textsInNormalRepresentation = (0, $830de6b205d78ea3$export$dbe72820abab9377)(...texts);
        const textsForPrint = textsInNormalRepresentation.join(" ");
        let logText = `\n[ ERROR ] ${currentTime} | ${textsForPrint}`;
        (0, $830de6b205d78ea3$export$28d70ad760c155a4)(logText, this.#logFileName, this.#separeteLogsByDate);
        return new Error(logText);
    }
    /**
     * Some suspicious things, noticeable in console
     * EG on server start database logging turn off
     * @param text
     */ warn(...texts) {
        if (!this.#aboveSelectedLogLevel("warn")) return;
        const currentTime = (0, $830de6b205d78ea3$export$2364d538c15eb8db)();
        (0, $830de6b205d78ea3$export$cc349de0efd0b6c9)("[ WARNING ] ", "yellow", `${currentTime} | `, ...texts);
        const textsInNormalRepresentation = (0, $830de6b205d78ea3$export$dbe72820abab9377)(...texts);
        const textsForPrint = textsInNormalRepresentation.join(" ");
        let logText = `\n[ WARNING ] ${currentTime} | ${textsForPrint}`;
        (0, $830de6b205d78ea3$export$28d70ad760c155a4)(logText, this.#logFileName, this.#separeteLogsByDate);
    }
    /**
     * Some important things, noticeable in console
     * @param text
     */ important(...texts) {
        if (!this.#aboveSelectedLogLevel("important")) return;
        const currentTime = (0, $830de6b205d78ea3$export$2364d538c15eb8db)();
        (0, $830de6b205d78ea3$export$cc349de0efd0b6c9)("[ IMPORTANT ] ", "blue", `${currentTime} | `, ...texts);
        const textsInNormalRepresentation = (0, $830de6b205d78ea3$export$dbe72820abab9377)(...texts);
        const textsForPrint = textsInNormalRepresentation.join(" ");
        let logText = `\n[ IMPORTANT ] ${currentTime} | ${textsForPrint}`;
        (0, $830de6b205d78ea3$export$28d70ad760c155a4)(logText, this.#logFileName, this.#separeteLogsByDate);
    }
    /**
     * Not noticeable in console
     * @param text
     */ info(...texts) {
        if (!this.#aboveSelectedLogLevel("info")) return;
        const currentTime = (0, $830de6b205d78ea3$export$2364d538c15eb8db)();
        (0, $830de6b205d78ea3$export$cc349de0efd0b6c9)("[ INFO ] ", "lightblue", `${currentTime} | `, ...texts);
        const textsInNormalRepresentation = (0, $830de6b205d78ea3$export$dbe72820abab9377)(...texts);
        const textsForPrint = textsInNormalRepresentation.join(" ");
        let logText = `\n[ INFO ] ${currentTime} | ${textsForPrint}`;
        (0, $830de6b205d78ea3$export$28d70ad760c155a4)(logText, this.#logFileName, this.#separeteLogsByDate);
    }
    /**
     * Gray colored log, use it for less important things than info.
     * You can turn off verbose logs (not show it in console, browser, file)
     * by setting log level to success: logging.setLogLevel('success')
     * @param text
     */ verbose(...texts) {
        if (!this.#aboveSelectedLogLevel("verbose")) return;
        const currentTime = (0, $830de6b205d78ea3$export$2364d538c15eb8db)();
        (0, $830de6b205d78ea3$export$cc349de0efd0b6c9)("[ VERBOSE ] ", "verbose_color", `${currentTime} | `, ...texts);
        const textsInNormalRepresentation = (0, $830de6b205d78ea3$export$dbe72820abab9377)(...texts);
        const textsForPrint = textsInNormalRepresentation.join(" ");
        let logText = `\n[ VERBOSE ] ${currentTime} | ${textsForPrint}`;
        (0, $830de6b205d78ea3$export$28d70ad760c155a4)(logText, this.#logFileName, this.#separeteLogsByDate);
    }
    success(...texts) {
        if (!this.#aboveSelectedLogLevel("success")) return;
        const currentTime = (0, $830de6b205d78ea3$export$2364d538c15eb8db)();
        (0, $830de6b205d78ea3$export$cc349de0efd0b6c9)("[ SUCCESS ] ", "green", `${currentTime} | `, ...texts);
        const textsInNormalRepresentation = (0, $830de6b205d78ea3$export$dbe72820abab9377)(...texts);
        const textsForPrint = textsInNormalRepresentation.join(" ");
        let logText = `\n[ SUCCESS ] ${currentTime} | ${textsForPrint}`;
        (0, $830de6b205d78ea3$export$28d70ad760c155a4)(logText, this.#logFileName, this.#separeteLogsByDate);
    }
     #aboveSelectedLogLevel(testedLogLevel) {
        const selectedLogLevel = this.#logLevel;
        const wantedLogLevel = $9506e65438fa5fe0$var$loggingValues[testedLogLevel];
        return wantedLogLevel <= selectedLogLevel;
    }
}
const $9506e65438fa5fe0$var$logging = new $9506e65438fa5fe0$var$OurLogging();
var $9506e65438fa5fe0$export$2e2bcd8739ae039 = $9506e65438fa5fe0$var$logging;


var $f95e119a9c380ed1$export$2e2bcd8739ae039 = (0, $9506e65438fa5fe0$export$2e2bcd8739ae039);


export {$f95e119a9c380ed1$export$2e2bcd8739ae039 as default};
